use_wifi = False

if (use_wifi):

    import os
    import machine
    import pycom

    # turn off blue LED heartbeat
    pycom.heartbeat(False)

    uart = machine.UART(0, 115200)
    os.dupterm(uart)

    known_nets = {
        'DINALAB': {'pwd': 'iloveyardpigs'},
        'Rojo': {'pwd': 'eggsmartiniaviationmeatball'},
        # '<net>': {'pwd': '<password>', 'wlan_config':  ('10.0.0.114', '255.255.0.0', '10.0.0.1', '10.0.0.1')}, # (ip, subnet_mask, gateway, DNS_server)
    }

    if machine.reset_cause() != machine.SOFT_RESET:
        from network import WLAN
        wl = WLAN()
        wl.mode(WLAN.STA)
        original_ssid = wl.ssid()
        original_auth = wl.auth()

        print("Scanning for known wifi nets")
        available_nets = wl.scan()
        nets = frozenset([e.ssid for e in available_nets])

        known_nets_names = frozenset([key for key in known_nets])
        net_to_use = list(nets & known_nets_names)
        try:
            net_to_use = net_to_use[0]
            net_properties = known_nets[net_to_use]
            pwd = net_properties['pwd']
            sec = [e.sec for e in available_nets if e.ssid == net_to_use][0]
            if 'wlan_config' in net_properties:
                wl.ifconfig(config=net_properties['wlan_config'])
            wl.connect(net_to_use, (sec, pwd), timeout=10000)
            while not wl.isconnected():
                machine.idle() # save power while waiting
            print("Connected to "+net_to_use+" with IP address:" + wl.ifconfig()[0])

        except Exception as e:
            print("Failed to connect to any known network, going into AP mode")
            wl.init(mode=WLAN.AP, ssid=original_ssid, auth=original_auth, channel=6, antenna=WLAN.INT_ANT)
